<?php
/**
 * Copyright(c) 2000-2007 LOCKON CO.,LTD. All Rights Reserved.
 *
 * http://www.lockon.co.jp/
 */

/**
 *  SC_Query饹
 *
 *  @author     LOCKON CO.,LTD.
 *  @access     public
 */
class SC_Query {
   /**#@+
    * @access private
    */
    
   /**
    * SC_DBConn֥
    * @var SC_DBConn
    */
    var $conn;
    
   /**
    * LIMIT,OFFSET 
    * @var string
    */
    var $option;
    
   /**
    * WHERE 
    * @var string
    */
    var $where;
    
   /**
    * GROUP BY 
    * @var string
    */
    var $groupby;
    
   /**
    * ORDER BY 
    * @var string
    */
    var $order;
    
    /**#@-*/
    
    /**
     *  SC_Query饹Υ󥹥ȥ饯
     *
     *  @access public
     *  @param  string  $dsn      DSN
     *  @param  boolean $err_disp 顼ɽԤɤ
     *  @param  boolean $new      DB³Ԥɤ
     */
    function SC_Query($dsn = "", $err_disp = true, $new = false) {
        $this->conn = new SC_DBconn($dsn, $err_disp, $new);
        $this->where   = "";
        $this->option  = "";
        $this->groupby = "";
        return $this->conn; //?
    }
    
    /**
     *  DB顼Ƚ
     *
     *  @access public
     *  @return boolean true Իfalse
     */
    function isError() {
        if(PEAR::isError($this->conn->conn)) {
            return true;
        }
        return false;
    }
    
    /**
     *  COUNTʸμ¹
     *
     *  @access public
     *  @param  string  $table  ơ֥̾
     *  @param  string  $where  WHERE
     *  @param  array   $arrval ץ졼ۥ
     *  @return string  쥳ɷ
     */
    function count($table, $where = "", $arrval = array()) {
        if(strlen($where) <= 0) {
            $sqlse = "SELECT COUNT(*) FROM $table";
        } else {
            $sqlse = "SELECT COUNT(*) FROM $table WHERE $where";
        }
        // ʸμ¹
        $ret = $this->conn->getOne($sqlse, $arrval);
        return $ret;
    }
    
    /**
     *  SELECTʸμ¹
     *
     *  @access public
     *  @param  string  $col    ̾
     *  @param  string  $table  ơ֥̾
     *  @param  string  $where  WHERE
     *  @param  array   $arrval ץ졼ۥ
     *  @return array   SELECTʸμ¹Է
     */
    function select($col, $table, $where = "", $arrval = array()){
        $sqlse = $this->getsql($col, $table, $where);
        $ret = $this->conn->getAll($sqlse, $arrval);
        return $ret;
    }
    
    /**
     *  Ǹ˼¹ԤSQLʸ
     *
     *  @access public
     *  @param  boolean $disp SQLʸprint뤫ɤ
     *  @return string  $disp==falseξ硧Ǹ˼¹ԤSQLʸ$disp==trueξ硧ʤ
     */
    function getLastQuery($disp = true) {
        $sql = $this->conn->conn->last_query;
        if($disp) { 
            print($sql.";<br />\n");
        }
        return $sql;
    }

	function commit() {
		$this->conn->query("COMMIT");
	}
	
	function begin() {
		$this->conn->query("BEGIN");
	}
	
	function rollback() {
		$this->conn->query("ROLLBACK");
	}
	
	function exec($str, $arrval = array()) {
		$this->conn->query($str, $arrval);
	}

	function autoselect($col, $table, $arrwhere = array(), $arrcon = array()) {
		$strw = "";			
		$find = false;
		foreach ($arrwhere as $key => $val) {
			if(strlen($val) > 0) {
				if(strlen($strw) <= 0) {
					$strw .= $key ." LIKE ?";
				} else if(strlen($arrcon[$key]) > 0) {
					$strw .= " ". $arrcon[$key]. " " . $key ." LIKE ?";
				} else {
					$strw .= " AND " . $key ." LIKE ?";
				}
				
				$arrval[] = $val;
			}
		}
		
		if(strlen($strw) > 0) {
			$sqlse = "SELECT $col FROM $table WHERE $strw ".$this->option;
		} else {
			$sqlse = "SELECT $col FROM $table ".$this->option;
		}
		$ret = $this->conn->getAll($sqlse, $arrval);
		return $ret;
	}
	
	function getall($sql, $arrval = array()) {
		$ret = $this->conn->getAll($sql, $arrval);
		return $ret;
	}

    /**
     *  SELECTʸۤ
     *
     *  @access public
     *  @param  string  $col    ̾
     *  @param  string  $table  ơ֥̾
     *  @param  string  $where  WHERE
     *  @return string  SQLʸ
     */
    function getsql($col, $table, $where="") {
        if($where != "") {
            // $whereͥ褷Ƽ¹Ԥ롣
            $sqlse = "SELECT $col FROM $table WHERE $where " . $this->groupby . " " . $this->order . " " . $this->option;
        } else {
            if($this->where != "") {
                    $sqlse = "SELECT $col FROM $table WHERE $this->where " . $this->groupby . " " . $this->order . " " . $this->option;
                } else {
                    $sqlse = "SELECT $col FROM $table " . $this->groupby . " " . $this->order . " " . $this->option;
            }
        }
        return $sqlse;
    }
    
    /**
     *  WHERE,GROUPBY,ORDERBYʳΥץʥʶ򥻥åȤ
     *
     *  @access public
     *  @param  string  $str ץ˻Ѥʸ
     */
    function setoption($str) {
        $this->option = $str;
    }
    
    /**
     *  LIMIT硢OFFSET򥻥åȤ
     *
     *  @access public
     *  @param  mixed   $limit  LIMITη
     *  @param  mixed   $offset OFFSETη
     *  @param  string  $return LIMIT,OFFSETreturn뤫ɤ
     *  @return string  LIMIT,OFFSET
     */
    function setlimitoffset($limit, $offset = 0, $return = false) {
        if (is_numeric($limit) && is_numeric($offset)){
            
            $option.= " LIMIT " . $limit;
            $option.= " OFFSET " . $offset;
            
            if($return){
                return $option;
            }else{
                $this->option.= $option;
            }
        }
    }

    /**
     *  GROUP BY 򥻥åȤ
     *
     *  @access public
     *  @param  string  $str ̾
     */
    function setgroupby($str) {
        $this->groupby = "GROUP BY " . $str;
    }
    
    /**
     *  WHERE 򥻥åȤ(AND)
     *
     *  @access  public
     *  @param   string  $str WHERE 
     *  @example $objQuery->andWhere('product_id = ?');
     */
    function andwhere($str) {
        if($this->where != "") {
            $this->where .= " AND " . $str;
        } else {
            $this->where = $str;
        }
    }
    
    /**
     *  WHERE 򥻥åȤ(OR)
     *
     *  @access  public
     *  @param   string  $str WHERE 
     *  @example $objQuery->orWhere('product_id = ?');
     */
    function orwhere($str) {
        if($this->where != "") {
            $this->where .= " OR " . $str;
        } else {
            $this->where = $str;
        }
    }
    
    /**
     *  WHERE 򥻥åȤ
     *
     *  @access  public
     *  @param   string  $str WHERE 
     *  @example $objQuery->setWhere('product_id = ?');
     */
    function setwhere($str) {
        $this->where = $str;
    }
    
    /**
     *  ORDER BY 򥻥åȤ
     *
     *  @access  public
     *  @param   string  $str ̾
     *  @example $objQuery->setorder("rank DESC");
     */
    function setorder($str) {
        $this->order = "ORDER BY " . $str;
    }
    
    /**
     *  LIMIT 򥻥åȤ
     *
     *  @access  public
     *  @param   mixed  $limit LIMITη
     *  @example $objQuery->setlimit(50);
     */
    function setlimit($limit){
        if ( is_numeric($limit)){
            $this->option = " LIMIT " .$limit;
        }   
    }
    
    /**
     *  OFFSET 򥻥åȤ
     *
     *  @access  public
     *  @param   mixed  $offset OFFSETη
     *  @example $objQuery->setOffset(30);
     */
    function setoffset($offset) {
        if ( is_numeric($offset)){
            $this->offset = " OFFSET " .$offset;
        }   
    }
    
    /**
     *  INSERTʸ¹Ԥ
     *
     *  @access  public
     *  @param   string  $table  ơ֥̾
     *  @param   array   $sqlval (̾ => )Ϣ
     *  
     *  @return  mixed   $result DB_Error֥(Ի)ޤDB_OK()ޤfalse(बĤʤ)
     */
	function insert($table, $sqlval) {
		$strcol = '';
		$strval = '';
		$find = false;
		
		if(count($sqlval) <= 0 ) return false;
		
		foreach ($sqlval as $key => $val) {
			$strcol .= $key . ',';
			if(eregi("^Now\(\)$", $val)) {
				$strval .= 'Now(),';
			} else {
				$strval .= '?,';
				if($val != ""){
					$arrval[] = $val;
				} else {
					$arrval[] = NULL;
				}
			}
			$find = true;
		}
		if(!$find) {
			return false;
		}
		// ʸ","
		$strcol = ereg_replace(",$","",$strcol);
		// ʸ","
		$strval = ereg_replace(",$","",$strval);
		$sqlin = "INSERT INTO $table(" . $strcol. ") VALUES (" . $strval . ")";
		
		// INSERTʸμ¹
		$ret = $this->conn->query($sqlin, $arrval);
		
		return $ret;		
	}
	
    /**
     *  INSERTʸ¹Ԥ
     *
     *  @access  public
     *  @param   string  $table  ơ֥̾
     *  @param   array   $sqlval (̾ => )Ϣ
     *  
     *  @return  mixed   $result DB_Error֥(Ի)ޤDB_OK()ޤfalse(बĤʤ)
     */
	function fast_insert($table, $sqlval) {
		$strcol = '';
		$strval = '';
		$find = false;
		
		foreach ($sqlval as $key => $val) {
				$strcol .= $key . ',';
				if($val != ""){
					$eval = pg_escape_string($val);
					$strval .= "'$eval',";
				} else {
					$strval .= "NULL,";
				}
				$find = true;
		}
		if(!$find) {
			return false;
		}
		// ʸ","
		$strcol = ereg_replace(",$","",$strcol);
		// ʸ","
		$strval = ereg_replace(",$","",$strval);
		$sqlin = "INSERT INTO $table(" . $strcol. ") VALUES (" . $strval . ")";
		
		// INSERTʸμ¹
		$ret = $this->conn->query($sqlin);
		
		return $ret;
	}
	
	
	// UPDATEʸ¹
	// $table	:ơ֥̾
	// $sqlval	:̾ => ͤγǼ줿ϥå
	// $where	:WHEREʸ
	function update($table, $sqlval, $where = "", $arradd = "", $addcol = "") {
		$strcol = '';
		$strval = '';
		$find = false;
		foreach ($sqlval as $key => $val) {
			if(eregi("^Now\(\)$", $val)) {
				$strcol .= $key . '= Now(),';
			} else {
				$strcol .= $key . '= ?,';
				if($val != ""){
					$arrval[] = $val;
				} else {
					$arrval[] = NULL;
				}
			}
			$find = true;
		}
		if(!$find) {
			return false;
		}
		
		if($addcol != "") {
			foreach($addcol as $key => $val) {
				$strcol .= "$key = $val,";
			}
		}
				
		// ʸ","
		$strcol = ereg_replace(",$","",$strcol);
		// ʸ","
		$strval = ereg_replace(",$","",$strval);
		
		if($where != "") {
			$sqlup = "UPDATE $table SET $strcol WHERE $where";
		} else {
			$sqlup = "UPDATE $table SET $strcol";
		}
		
		if(is_array($arradd)) {
			// ץ졼ۥѤɲ
			foreach($arradd as $val) {
				$arrval[] = $val;
			}
		}
		
		// INSERTʸμ¹
		$ret = $this->conn->query($sqlup, $arrval);
		return $ret;		
	}

	// MAXʸμ¹
	function max($table, $col, $where = "", $arrval = array()) {
		if(strlen($where) <= 0) {
			$sqlse = "SELECT MAX($col) FROM $table";
		} else {
			$sqlse = "SELECT MAX($col) FROM $table WHERE $where";
		}
		// MAXʸμ¹
		$ret = $this->conn->getOne($sqlse, $arrval);
		return $ret;
	}
	
	// MINʸμ¹
	function min($table, $col, $where = "", $arrval = array()) {
		if(strlen($where) <= 0) {
			$sqlse = "SELECT MIN($col) FROM $table";
		} else {
			$sqlse = "SELECT MIN($col) FROM $table WHERE $where";
		}
		// MINʸμ¹
		$ret = $this->conn->getOne($sqlse, $arrval);
		return $ret;
	}
	
	// Υͤ
	function get($table, $col, $where = "", $arrval = array()) {
		if(strlen($where) <= 0) {
			$sqlse = "SELECT $col FROM $table";
		} else {
			$sqlse = "SELECT $col FROM $table WHERE $where";
		}
		// SQLʸμ¹
		$ret = $this->conn->getOne($sqlse, $arrval);
		return $ret;
	}
	
	function getone($sql, $arrval = array()) {
		// SQLʸμ¹
		$ret = $this->conn->getOne($sql, $arrval);
		return $ret;
		
	}
		
	// Ԥ
	function getrow($table, $col, $where = "", $arrval = array()) {
		if(strlen($where) <= 0) {
			$sqlse = "SELECT $col FROM $table";
		} else {
			$sqlse = "SELECT $col FROM $table WHERE $where";
		}
		// SQLʸμ¹
		$ret = $this->conn->getRow($sqlse, $arrval);
		
		return $ret;
	}
		
	// 쥳ɤκ
	function delete($table, $where = "", $arrval = array()) {
		if(strlen($where) <= 0) {
			$sqlde = "DELETE FROM $table";
		} else {
			$sqlde = "DELETE FROM $table WHERE $where";
		}
		$ret = $this->conn->query($sqlde, $arrval);
		return $ret;
	}
	
    //ꤷΰֺǸ˥쥳ɤ
	function nextval($table, $colname) {
		$sql = "";
		// postgresqlmysqlȤǽʬ
		if (DB_TYPE == "pgsql") {
			$seqtable = $table . "_" . $colname . "_seq";
			$sql = "SELECT NEXTVAL('$seqtable')";
            $ret = $this->conn->getOne($sql);
		}else if (DB_TYPE == "mysql") {
            $sql = "SELECT last_insert_id();";
		    $ret = $this->conn->getOne($sql);
        }
		
		
		return $ret;
	}
	
	function currval($table, $colname) {
		$sql = "";
		if (DB_TYPE == "pgsql") {
			$seqtable = $table . "_" . $colname . "_seq";
			$sql = "SELECT CURRVAL('$seqtable')";
		}else if (DB_TYPE == "mysql") {
			$sql = "SELECT last_insert_id();";
		}
		$ret = $this->conn->getOne($sql);
		
		return $ret;
	}	
	
	function setval($table, $colname, $data) {
		$sql = "";
		if (DB_TYPE == "pgsql") {
			$seqtable = $table . "_" . $colname . "_seq";
			$sql = "SELECT SETVAL('$seqtable', $data)";
			$ret = $this->conn->getOne($sql);
		}else if (DB_TYPE == "mysql") {
			$sql = "ALTER TABLE $table AUTO_INCREMENT=$data";
			$ret = $this->conn->query($sql);
		}
		
		return $ret;
	}		
	
	function query($n ,$arr = "", $ignore_err = false){
		$result = $this->conn->query($n, $arr, $ignore_err);
		return $result;
	}
	
	// auto_increment
	function get_auto_increment($table_name){
		// å
		$this->BEGIN();
		
		// Increment
		$arrRet = $this->getAll("SHOW TABLE STATUS LIKE ?", array($table_name));
		$auto_inc_no = $arrRet[0]["Auto_increment"];
		
		// ͤ򥫥ȥåפƤ
		$this->conn->query("ALTER TABLE $table_name AUTO_INCREMENT=?" , $auto_inc_no + 1);
		
		// 
		$this->COMMIT();
		
		return $auto_inc_no;
	}
}
?>